#include "neo.h"
#include <strings.h>
#include <string.h>

void neo_global_create(neo_global *g)
{
  g->argv0=NULL;
  g->readcom=strdup("public");
  g->writecom=strdup("public");
  neo_global_set_burst(g, 1);
#ifdef MIT
  g->keyfile=strdup("/afs/.net.mit.edu/tools/lib/port/agent_lists.kretch");
#else
  g->keyfile=strdup("/usr/local/etc/neo.keyfile");
#endif
  g->version=strdup(NEO_VERSION_STRING);
  neo_global_set_statsdelay(g, 5);
  neo_global_set_areyousure_ask(g);
  neo_global_set_timeout(g, 8);
  neo_global_set_noverbose(g);
  neo_global_set_nodebug(g);
  g->macmode=NEO_GLOBAL_MACMODE_STANDARD;
}

void neo_global_set_macmode(neo_global *g, int mode)
{
  g->macmode=mode;
}

int neo_global_set_macmode_from_string(neo_global *g, char *in)
{
  if (!strcmp(in, "standard")) {
    g->macmode=NEO_GLOBAL_MACMODE_STANDARD;
  } else if (!strcmp(in, "cisco")) {
    g->macmode=NEO_GLOBAL_MACMODE_CISCO;
  } else if (!strcmp(in, "dash")) {
    g->macmode=NEO_GLOBAL_MACMODE_DASH;
  } else {
    return(-1);
  }
  return(0);
}

int neo_global_get_macmode(neo_global *g)
{
  return(g->macmode);
}

char *neo_global_get_macmode_string(neo_global *g)
{
  if (g->macmode==NEO_GLOBAL_MACMODE_STANDARD) {
    return("standard");
  } else if (g->macmode==NEO_GLOBAL_MACMODE_CISCO) {
    return("cisco");
  } else if (g->macmode==NEO_GLOBAL_MACMODE_DASH) {
    return("dash");
  }
  return("invalid");
}

void neo_global_set_argv0(neo_global *g, char *in)
{
  if (g->argv0) free(g->argv0);
  g->argv0=strdup(in);
}

char *neo_global_get_argv0(neo_global *g)
{
  if (g->argv0) return(g->argv0);
  return("");
}

void neo_global_set_burst(neo_global *g, int burst)
{
  g->burst=burst;
}

int neo_global_get_burst(neo_global *g)
{
  return(g->burst);
}

void neo_global_set_readcom(neo_global *g, char *in)
{
  if (g->readcom) free(g->readcom);
  g->readcom=strdup(in);
}

char *neo_global_get_readcom(neo_global *g)
{
  if (g->readcom) return(g->readcom);
  return("");
}

void neo_global_set_writecom(neo_global *g, char *in)
{
  if (g->writecom) free(g->writecom);
  g->writecom=strdup(in);
}

char *neo_global_get_writecom(neo_global *g)
{
  if (g->writecom) return(g->writecom);
  return("");
}

void neo_global_set_keyfile(neo_global *g, char *in)
{
  if (g->keyfile) free(g->keyfile);
  g->keyfile=strdup(in);
}

char *neo_global_get_keyfile(neo_global *g)
{
  if (g->keyfile) return(g->keyfile);
  return("");
}

void neo_global_set_version(neo_global *g, char *in)
{
  if (g->version) free(g->version);
  g->version=strdup(in);
}

char *neo_global_get_version(neo_global *g)
{
  if (g->version) return(g->version);
  return("");
}

void neo_global_set_statsdelay(neo_global *g, int d)
{
  g->statsdelay=d;
}

int neo_global_get_statsdelay(neo_global *g)
{
  return(g->statsdelay);
}

void neo_global_set_areyousure_ask(neo_global *g)
{
  g->areyousure=0;
}

void neo_global_set_areyousure_yes(neo_global *g)
{
  g->areyousure=1;
}

void neo_global_set_areyousure_no(neo_global *g)
{
  g->areyousure=-1;
}

int neo_global_is_areyousure_ask(neo_global *g)
{
  if (g->areyousure==0) return(1);
  return(0);
}

int neo_global_is_areyousure_yes(neo_global *g)
{
  if (g->areyousure==1) return(1);
  return(0);
}

int neo_global_is_areyousure_no(neo_global *g)
{
  if (g->areyousure==-1) return(1);
  return(0);
}
 
int neo_global_get_timeout(neo_global *g)
{
  return(g->snmptimeout);
}

void neo_global_set_timeout(neo_global *g, int i)
{
  g->snmptimeout=i;
}

void neo_global_set_nodebug(neo_global *g)
{
  g->debug=0;
}

void neo_global_set_debug(neo_global *g)
{
  g->debug=1;
}

int neo_global_is_debug(neo_global *g)
{
  if (g->debug==1) return(1);
  return(0);
}

void neo_global_set_noverbose(neo_global *g)
{
  g->verbose=0;
}

void neo_global_set_verbose(neo_global *g)
{
  g->verbose=1;
}

int neo_global_is_verbose(neo_global *g)
{
  if (g->verbose==1) return(1);
  return(0);
}
